<?php

namespace Drupal\widget_provider_example\Plugin\WidgetProvider;

use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\widget_provider_api\Attribute\WidgetProvider;
use Drupal\widget_provider_api\WidgetProviderBase;

/**
 * A Iframe Widget Example class.
 *
 * It renders an Iframe as a widget.
 */
#[WidgetProvider(
  id: 'widget-provider-example:widget-provider-iframe-example',
  label: new TranslatableMarkup('Widget Provider Iframe Example'),
  description: new TranslatableMarkup('Renders an iframe as a widget.'),
)]
class WidgetProviderIFrameExample extends WidgetProviderBase {

  /**
   * {@inheritdoc}
   */
  public function buildContent() {
    return $this->buildIframe('https://www.google.com/');
  }

  /**
   * Function for rendering an iframe.
   *
   * @param string $url
   *   The URL to be rendered in the iframe.
   *
   * @return array
   *   The iframe render array.
   */
  public function buildIframe($url) {
    return [
      '#type' => 'inline_template',
      '#template' => '<iframe src="{{ url }}"></iframe>',
      '#context' => [
        'url' => $url,
      ],
    ];
  }

}
