<?php

namespace Drupal\widget_provider_example\Plugin\WidgetProvider;

use Drupal\Component\Serialization\Json;
use Symfony\Component\HttpFoundation\JsonResponse;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\widget_provider_api\Attribute\WidgetProvider;
use Drupal\widget_provider_api\WidgetProviderBase;

/**
 * A JSON Widget Example class.
 */
#[WidgetProvider(
  id: 'widget-provider-example:widget-provider-json-example',
  label: new TranslatableMarkup('Widget Provider JSON Example'),
  description: new TranslatableMarkup('Renders JSON as a widget.'),
)]
class WidgetProviderJsonExample extends WidgetProviderBase {

  /**
   * {@inheritdoc}
   */
  public function buildContent() {
    return JsonResponse::fromJsonString(Json::encode(['data' => 'This is an example from JSON Example']));
  }

}
